<?php

namespace \Losc\CucmBundle\Model\Webservice\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for XCallerFilterList StructType
 * @subpackage Structs
 */
class XCallerFilterList extends AbstractStructBase
{
    /**
     * The name
     * Meta information extracted from the WSDL
     * - base: xsd:string
     * - maxLength: 50
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: false
     * @var string
     */
    public $name;
    /**
     * The isAllowedType
     * Meta information extracted from the WSDL
     * - base: xsd:string
     * - default: false
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: false
     * - pattern: (t)|(f)|(true)|(false)|(0)|(1)
     * @var string
     */
    public $isAllowedType;
    /**
     * The description
     * Meta information extracted from the WSDL
     * - base: xsd:string
     * - maxLength: 128
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: false
     * @var string
     */
    public $description;
    /**
     * The endUserIdName
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \\Losc\CucmBundle\Model\Webservice\StructType\XFkType
     */
    public $endUserIdName;
    /**
     * The members
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \\Losc\CucmBundle\Model\Webservice\StructType\Members
     */
    public $members;
    /**
     * Constructor method for XCallerFilterList
     * @uses XCallerFilterList::setName()
     * @uses XCallerFilterList::setIsAllowedType()
     * @uses XCallerFilterList::setDescription()
     * @uses XCallerFilterList::setEndUserIdName()
     * @uses XCallerFilterList::setMembers()
     * @param string $name
     * @param string $isAllowedType
     * @param string $description
     * @param \\Losc\CucmBundle\Model\Webservice\StructType\XFkType $endUserIdName
     * @param \\Losc\CucmBundle\Model\Webservice\StructType\Members $members
     */
    public function __construct($name = null, $isAllowedType = 'false', $description = null, \\Losc\CucmBundle\Model\Webservice\StructType\XFkType $endUserIdName = null, \\Losc\CucmBundle\Model\Webservice\StructType\Members $members = null)
    {
        $this
            ->setName($name)
            ->setIsAllowedType($isAllowedType)
            ->setDescription($description)
            ->setEndUserIdName($endUserIdName)
            ->setMembers($members);
    }
    /**
     * Get name value
     * @return string
     */
    public function getName()
    {
        return $this->name;
    }
    /**
     * Set name value
     * @param string $name
     * @return \\Losc\CucmBundle\Model\Webservice\StructType\XCallerFilterList
     */
    public function setName($name = null)
    {
        $this->name = $name;
        return $this;
    }
    /**
     * Get isAllowedType value
     * @return string
     */
    public function getIsAllowedType()
    {
        return $this->isAllowedType;
    }
    /**
     * Set isAllowedType value
     * @param string $isAllowedType
     * @return \\Losc\CucmBundle\Model\Webservice\StructType\XCallerFilterList
     */
    public function setIsAllowedType($isAllowedType = 'false')
    {
        $this->isAllowedType = $isAllowedType;
        return $this;
    }
    /**
     * Get description value
     * @return string|null
     */
    public function getDescription()
    {
        return $this->description;
    }
    /**
     * Set description value
     * @param string $description
     * @return \\Losc\CucmBundle\Model\Webservice\StructType\XCallerFilterList
     */
    public function setDescription($description = null)
    {
        $this->description = $description;
        return $this;
    }
    /**
     * Get endUserIdName value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \\Losc\CucmBundle\Model\Webservice\StructType\XFkType|null
     */
    public function getEndUserIdName()
    {
        return isset($this->endUserIdName) ? $this->endUserIdName : null;
    }
    /**
     * Set endUserIdName value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \\Losc\CucmBundle\Model\Webservice\StructType\XFkType $endUserIdName
     * @return \\Losc\CucmBundle\Model\Webservice\StructType\XCallerFilterList
     */
    public function setEndUserIdName(\\Losc\CucmBundle\Model\Webservice\StructType\XFkType $endUserIdName = null)
    {
        if (is_null($endUserIdName) || (is_array($endUserIdName) && empty($endUserIdName))) {
            unset($this->endUserIdName);
        } else {
            $this->endUserIdName = $endUserIdName;
        }
        return $this;
    }
    /**
     * Get members value
     * @return \\Losc\CucmBundle\Model\Webservice\StructType\Members|null
     */
    public function getMembers()
    {
        return $this->members;
    }
    /**
     * Set members value
     * @param \\Losc\CucmBundle\Model\Webservice\StructType\Members $members
     * @return \\Losc\CucmBundle\Model\Webservice\StructType\XCallerFilterList
     */
    public function setMembers(\\Losc\CucmBundle\Model\Webservice\StructType\Members $members = null)
    {
        $this->members = $members;
        return $this;
    }
}
